/* Target definitions for GCC for Juniper/ARM
   Copyright (C) 1988, 1991, 1995, 2000, 2001, 2002, 2004, 2008
   Free Software Foundation, Inc.

This file is part of GCC.

GCC is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

GCC is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with GCC; see the file COPYING.  If not, write to
the Free Software Foundation, 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.  */

/* Run-time Target Specification.  */
#undef  TARGET_VERSION
#define TARGET_VERSION	fputs (" (ARM/ELF Juniper)", stderr);

/* Output assembler code to FILE to call the profiler.
   This target does not require the label argument to mcount.  */
#undef NO_PROFILE_COUNTERS
#define NO_PROFILE_COUNTERS 1

#undef  SUBTARGET_EXTRA_SPECS   /* previously defined in freebsd.h  */
#define SUBTARGET_EXTRA_SPECS \
  { "junos_dynamic_linker", \
    "/usr/libexec/ld-elf.so.1" }

/* Output assembler code to FILE to increment profiler label.  */
#undef FUNCTION_PROFILER
#define FUNCTION_PROFILER(STREAM, LABELNO)  	\
{							\
							\
  asm_fprintf (STREAM, "\tmov\t%r, %r\n\tbl\t",		\
	   IP_REGNUM, LR_REGNUM);			\
  assemble_name (STREAM, ARM_MCOUNT_NAME);		\
  fputc ('\n', STREAM);					\
}

#undef  LINK_SPEC
#define LINK_SPEC "							\
  %{mbig-endian:-EB} %{mlittle-endian:-EL} -X				\
  %{p:%nconsider using `-pg' instead of `-p' with gprof(1) }		\
  %{v:-V}								\
  %{assert*} %{R*} %{rpath*} %{defsym*}					\
  %{shared:-Bshareable %{h*} %{soname*}}				\
  %{!shared:								\
    %{!static:								\
      %{rdynamic:-export-dynamic}					\
      %{!dynamic-linker:-dynamic-linker %(junos_dynamic_linker) }}	\
    %{static:-Bstatic}}							\
  %{symbolic:-Bsymbolic}"

#undef LIB_SPEC
#define LIB_SPEC "							\
  %{!shared:								\
    %{!pg: %{pthread:-lpthread} -lc}					\
    %{pg: %{pthread:-lpthread_p} -lc_p}}				\
  %{shared:								\
    %{pthread:-lpthread}}						\
  "
/* Provide a STARTFILE_SPEC appropriate for JUNOS.  Here we add
   the magical crtbegin.o file (see crtstuff.c) which provides part
   of the support for getting C++ file-scope static object constructed
   before entering `main'.
*/

#undef STARTFILE_SPEC
#define STARTFILE_SPEC \
  "%{!shared: \
     %{pg:gcrt1.o%s} %{!pg:%{p:gcrt1.o%s} \
                       %{!p:%{profile:gcrt1.o%s} \
                         %{!profile:crt1.o%s}}}} \
   crti.o%s %{!shared:crtbegin.o%s} %{shared:crtbeginS.o%s}"

/* Provide a ENDFILE_SPEC appropriate for JUNOS.  Here we tack on
   the magical crtend.o file (see crtstuff.c) which provides part of
   the support for getting C++ file-scope static object constructed
   before entering `main', followed by a normal "finalizer" file,
   `crtn.o'.
 */

#undef ENDFILE_SPEC
#define ENDFILE_SPEC \
  "%{!shared:crtend.o%s} %{shared:crtendS.o%s} crtn.o%s"

/* Tell final.c that we don't need a label passed to mcount.  */

#undef MCOUNT_NAME
#define MCOUNT_NAME ".mcount"

#undef  SIZE_TYPE
#define SIZE_TYPE       "unsigned int"

#undef  PTRDIFF_TYPE
#define PTRDIFF_TYPE    "int"

/* aapcs is unsigned int, apcs is int */
#undef WCHAR_TYPE
#define WCHAR_TYPE (((arm_abi == ARM_ABI_AAPCS_LINUX) || (arm_abi == ARM_ABI_AAPCS)) ? "unsigned int" : "int")

#undef  WCHAR_TYPE_SIZE
#define WCHAR_TYPE_SIZE 32

#ifdef __ARM_EABI__
/* Clear the instruction cache from `BEG' to `END'.  This makes a
   call to the ARM32_SYNC_ICACHE architecture specific syscall.  */
#define CLEAR_INSN_CACHE(BEG, END)                         \
{                                                          \
  extern int sysarch(int number, void *args);              \
  struct {                                                 \
    unsigned int  addr;                                    \
    int           len;                                     \
  } s;                                                     \
  s.addr = (unsigned int)(BEG);                            \
  s.len = (END) - (BEG);                                   \
  (void)sysarch(0, &s);                                    \
}                                                                           
#endif
