/*
 * $Id: time.h 347264 2009-11-19 13:44:32Z kdickman $
 *
 * time.h -- shim header for g++ support
 *
 * Stu Grossman, March 2007
 *
 * Copyright (c) 2007, Juniper Networks, Inc.
 * All rights reserved.
 */

/*
 * pfe/include/time.h is just hopeless.  Most of what we want is in stdtime.h.
 * This file just tidies up a few things to make libstdc++ compile.
 */

#ifndef __LIBSTDCXX_EMBEDDED_TIME_H__
#define __LIBSTDCXX_EMBEDDED_TIME_H__

#ifdef __cplusplus
extern "C" {
#endif

#include "../../common/toolkits/stdtime/stdtime.h"

typedef unsigned long clock_t;

clock_t clock (void);
double difftime(time_t _time2, time_t _time1);
time_t time(time_t *_timer);

#ifdef __cplusplus
}
#endif

#endif /* __LIBSTDCXX_EMBEDDED_TIME_H__ */
