/*
 * $Id: assert.h 783309 2016-05-29 20:43:57Z ib-builder $
 *
 * assert.h -- shim header for g++ support
 *
 * Stu Grossman, June 2007
 *
 * Copyright (c) 2007, Juniper Networks, Inc.
 * All rights reserved.
 */

/*
 * This wrapper provides a way for libstdc++ (and possibly other 3rd party
 * code) to avoid the problems in pfe/include/assert.h.  pfe/include/assert.h
 * is a ukern-specific file which doesn't provide the standard assert() API.
 * Also, it defines an `__str' macro which interferes with one of the headers
 * supplied by libstdc++.
 *
 */

#ifndef __LIBSTDCXX_NATIVE_ASSERT_H__
#define __LIBSTDCXX_NATIVE_ASSERT_H__

#ifdef __cplusplus
extern "C" {
#endif

#ifdef __linux__
#undef USE_SYSTEM_ASSERT_H
#define USE_SYSTEM_ASSERT_H
#include_next <assert.h>
#else
#include </usr/include/assert.h>
#endif

#ifdef __cplusplus
}
#endif

#endif /* __LIBSTDCXX_NATIVE_ASSERT_H__ */
