/*
 * $Id: stddef.h 783309 2016-05-29 20:43:57Z ib-builder $
 *
 * stddef.h wrapper for C++
 *
 * Stu Grossman, June 2007
 *
 * Copyright (c) 2007, Juniper Networks, Inc.
 * All rights reserved.
 */

/*
 * This wrapper provides a way for libstdc++ (and possibly other 3rd party
 * code) to avoid the problems in pfe/include/stddef.h.  pfe/include/stddef.h
 * lacks many of the defs which are needed by the C++ <cstddef> header.
 */

#ifndef __LIBSTDCXX_NATIVE_STDDEF_H__
#define __LIBSTDCXX_NATIVE_STDDEF_H__

#ifdef __cplusplus
extern "C" {
#endif

#ifdef __linux__
#undef USE_SYSTEM_STDDEF_H
#define USE_SYSTEM_STDDEF_H
#include_next <stddef.h>
#else
#include </usr/include/stddef.h>
#endif

#ifdef __cplusplus
}
#endif

#endif /* __LIBSTDCXX_NATIVE_STDDEF_H__ */
